#include "cgroupdeal.h"
//#include </home/dingchenguang/Documents/qt/root/CgroupDbusReceive/CgroupDbusReceive/CgroupDeal.h>

//初始化cgroup，给三个分组foreground invisible cached的结构都添加三个子系统cpu memory freezer
CLibcgroup::CLibcgroup(void)
{
    int libcgroupReturn=1; //libcgroup返回0为正确，开始置1保证执行正确。
    libcgroupReturn=cgroup_init();//cgroup初始化,  先初始化，再执行创建、删除那些操作。
    if(libcgroupReturn!=0)
    {
        cout << "cgroup初始化失败" << endl;
//        printf("cgroup初始化失败\n");
    }
    else
    {
        cout << "cgroup初始化成功" << endl;
    }

    libcgroupReturn=1;
    ForegroundProcess = cgroup_new_cgroup("/ForegroundProcess");  //创建cgroup结构，前面是组名，后面/是文件夹名。
    cgroup_add_controller(ForegroundProcess, "cpu");
    cgroup_add_controller(ForegroundProcess, "blkio");
    cgroup_add_controller(ForegroundProcess, "freezer");

    InvisibleProcess = cgroup_new_cgroup("/InvisibleProcess");  //创建cgroup结构，结构包含cpu memory freezer
    cgroup_add_controller(InvisibleProcess, "cpu");
    cgroup_add_controller(InvisibleProcess, "blkio");
    cgroup_add_controller(InvisibleProcess, "freezer");

    CachedProcess = cgroup_new_cgroup("/CachedProcess");  //创建cgroup结构，结构包含cpu memory freezer
    cgroup_add_controller(CachedProcess, "cpu");
    cgroup_add_controller(CachedProcess, "blkio");
    cgroup_add_controller(CachedProcess, "freezer");;
}
CLibcgroup::~CLibcgroup(void)
{

}

//在内核中创建三个分组foreground invisible cached
int CLibcgroup::CreateCGroup()
{
    int libcgroupReturn=1; //libcgroup返回0为正确，开始置1保证执行正确。
    int errnomber=0;//50016这种错，是其他库的错误，用这个变量查

    //前端进程控制组
    libcgroupReturn=cgroup_create_cgroup(ForegroundProcess, 0);
    if(libcgroupReturn!=0)
    {
        cout << "foreground组创建失败，错误号" << libcgroupReturn << endl;
        if(libcgroupReturn==50016)
        {
            errnomber=cgroup_get_last_errno();
            cout << "其他库错误，错误号" << errnomber << endl;
            errnomber=0;
        }
        return 1;
    }
    else
    {
        cout << "foreground组创建成功" << libcgroupReturn << endl;
    }
    libcgroupReturn=1;

    //不可见进程控制组
    libcgroupReturn=cgroup_create_cgroup(InvisibleProcess, 0);
    if(libcgroupReturn!=0)
    {
        cout << "invisible组创建失败，错误号" << libcgroupReturn << endl;
        if(libcgroupReturn==50016)
        {
            errnomber=cgroup_get_last_errno();
            cout << "其他库错误，错误号" << errnomber << endl;
            errnomber=0;
        }
        return 1;
    }
    else
    {
        cout << "invisible组创建成功" << libcgroupReturn << endl;
    }
    Wirtecpurate(10 , "InvisibleProcess" );
    libcgroupReturn=1;

    //缓存进程控制组
    libcgroupReturn=cgroup_create_cgroup(CachedProcess, 0);
    if(libcgroupReturn!=0)
    {
        cout << "cached组创建失败，错误号" << libcgroupReturn << endl;
        if(libcgroupReturn==50016)
        {
            errnomber=cgroup_get_last_errno();
            cout << "其他库错误，错误号" << errnomber << endl;
        }
        return 1;
    }
    else
    {
        cout << "cached组创建成功" << libcgroupReturn << endl;
    }
    Wirtefreezerstate("FROZEN" , "CachedProcess");
    libcgroupReturn=1;
    return 0;
}

//pid是进程的pid 如162282，group是组名 如“foreground”。移动进程到组
int CLibcgroup::MoveProcess(int pid, string group)
{
    int libcgroupReturn=1;
    int errnomber=0;//50016这种错，是其他库的错误，用这个变量查
    if(group=="ForegroundProcess")
    {
        libcgroupReturn=cgroup_attach_task_pid(ForegroundProcess, pid);
        if(libcgroupReturn!=0)
        {
            cout << "进程" << pid << "移动进foreground分组失败，错误号" << libcgroupReturn << endl;
            if(libcgroupReturn==50016)
            {
                errnomber=cgroup_get_last_errno();
                cout << "其他库错误，错误号" << errnomber << ",请确定组名和进程号" << pid << endl;
                errnomber=0;
            }
            return 1;
        }
        else
        {
            cout << "进程" << pid << "移动进foreground分组成功," << libcgroupReturn << endl;
        }
        libcgroupReturn=1;
    }
    else if(group=="InvisibleProcess")
    {
        libcgroupReturn=cgroup_attach_task_pid(InvisibleProcess, pid);
        if(libcgroupReturn!=0)
        {
            cout << "进程" << pid << "移动进invisible分组失败，错误号" << libcgroupReturn << endl;
            if(libcgroupReturn==50016)
            {
                errnomber=cgroup_get_last_errno();
                cout << "其他库错误，错误号" << errnomber << ",请确定组名和进程号" << pid << endl;
                errnomber=0;
            }
            return 1;
        }
        else
        {
            cout << "进程" << pid << "移动进invisible分组成功," << libcgroupReturn << endl;
        }
        libcgroupReturn=1;
    }
    else if(group=="CachedProcess")
    {
        libcgroupReturn=cgroup_attach_task_pid(CachedProcess, pid);
        if(libcgroupReturn!=0)
        {
            cout << "进程" << pid << "移动进cached分组失败，错误号" << libcgroupReturn << endl;
            if(libcgroupReturn==50016)
            {
                errnomber=cgroup_get_last_errno();
                cout << "其他库错误，错误号" << errnomber << ",请确定组名和进程号" << pid << endl;
                errnomber=0;
            }
            return 1;
        }
        else
        {
            cout << "进程" << pid << "移动进cached分组成功," << libcgroupReturn << endl;
        }
        libcgroupReturn=1;
    }
    else
    {
        cout << "组名错误" << endl;
        return 1;
    }
    return 0;
}

//group是组名 如“foreground”。删除组
int CLibcgroup::DeleteCGroup(string group)
{
    int libcgroupReturn=1;
    int errnomber=0;//50016这种错，是其他库的错误，用这个变量查

    if(group=="ForegroundProcess")
    {
        libcgroupReturn=cgroup_delete_cgroup(ForegroundProcess, 0);
        if(libcgroupReturn!=0)
        {
            cout << "foreground分组删除失败，错误号" << libcgroupReturn << endl;
            if(libcgroupReturn==50016)
            {
                errnomber=cgroup_get_last_errno();
                cout << "其他库错误，错误号" << errnomber << ",请检查组名" << endl;
                errnomber=0;
            }
            return 1;
        }
        else
        {
            cout << "foreground分组删除成功，" << libcgroupReturn << endl;
        }
        libcgroupReturn=1;
    }
    else if(group=="InvisibleProcess")
    {
        libcgroupReturn=cgroup_delete_cgroup(InvisibleProcess, 0);
        if(libcgroupReturn!=0)
        {
            cout << "invisible分组删除失败，错误号" << libcgroupReturn << endl;
            if(libcgroupReturn==50016)
            {
                errnomber=cgroup_get_last_errno();
                cout << "其他库错误，错误号" << errnomber << ",请检查组名" << endl;
                errnomber=0;
            }
            return 1;
        }
        else
        {
            cout << "invisible分组删除成功，" << libcgroupReturn << endl;
        }
        libcgroupReturn=1;
    }
    else if(group=="CachedProcess")
    {
        libcgroupReturn=cgroup_delete_cgroup(CachedProcess, 0);
        if(libcgroupReturn!=0)
        {
            cout << "cached分组删除失败，错误号" << libcgroupReturn << endl;
            if(libcgroupReturn==50016)
            {
                errnomber=cgroup_get_last_errno();
                cout << "其他库错误，错误号" << errnomber << ",请检查组名" << endl;
                errnomber=0;
            }
            return 1;
        }
        else
        {
            cout << "cached分组删除成功，" << libcgroupReturn << endl;
        }
        libcgroupReturn=1;
    }
    else
    {
        cout << "组名错误" << endl;
        return 1;
    }
    return 0;
}

//删除三个组foreground invisible cached
int CLibcgroup::DeleteCGroup()
{
    int funreturn=1;
    int flag=0;
    funreturn=DeleteCGroup("ForegroundProcess");
    if(funreturn==1)
        flag=1;
    DeleteCGroup("InvisibleProcess");
    if(funreturn==1)
        flag=1;
    DeleteCGroup("CachedProcess");
    if(funreturn==1)
        flag=1;
    return flag;
}

//向文件写入数据
int CLibcgroup::Wirtecpurate(double rate , string group)
{
    int period = 100000;
    int quota = -1;
    rate = rate/100;
    QString fileName1 = "/sys/fs/cgroup/cpu,cpuacct";
    QString fileName2 = "/sys/fs/cgroup/cpu,cpuacct";
    if(group=="ForegroundProcess")
    {
        fileName1 = fileName1 + "/ForegroundProcess/cpu.cfs_period_us";
        fileName2 = fileName2 + "/ForegroundProcess/cpu.cfs_quota_us";
    }
    else if(group=="InvisibleProcess")
    {
        fileName1 = fileName1 + "/InvisibleProcess/cpu.cfs_period_us";
        fileName2 = fileName2 + "/InvisibleProcess/cpu.cfs_quota_us";
    }
    else if(group=="CachedProcess")
    {
        fileName1 = fileName1 + "/CachedProcess/cpu.cfs_period_us";
        fileName2 = fileName2 + "/CachedProcess/cpu.cfs_quota_us";
    }
    else
    {
        cout << "组名错误" << endl;
        return 1;
    }

    QFile file1(fileName1);
    if (! file1.exists())
    {
        cout << "文件不存在，请创建分组" << endl;
        return 1;
    }
    else{
        if(!file1.open(QIODevice::ReadOnly)){   //以读的方式打开文件
            qDebug()<<file1.errorString();
            return 1;
        }
        QByteArray buf = file1.readAll();//读取文件所有数据
        QString str = QString(buf);
        str.chop(1);
        period = str.toInt();
        file1.close();//关闭文件
    }

    QFile file2(fileName2);
    if (! file2.exists())
    {
        cout << "文件不存在，请创建分组" << endl;
        return 1;
    }
    else {
        if(!file2.open(QIODevice::WriteOnly|QFile::Truncate))//以写的方式打开文件，如果文件不存在则创建，
        {
            qDebug()<<file2.errorString();
            return 1;
        }
        quota = rate * period ;
        if (rate<0.01 || rate>1){
            quota = -1;
        }
        QString str = QString::number(quota);
        str = str+"\n";
        QByteArray buf = str.toUtf8();
        file2.write(buf);//写入文件，支持QByteArray和 char * 类型数据写入
        cout << "cpu占用率写入分组" << endl;
        file2.close();//关闭文件
    }
    return 0;
}

int CLibcgroup::Wirtefreezerstate(string state , string group)
{
    QString str;
    QByteArray buf;
    QString fileName1 = "/sys/fs/cgroup/freezer";
    if(group=="ForegroundProcess")
    {
        fileName1 = fileName1 + "/ForegroundProcess/freezer.state";
    }
    else if(group=="InvisibleProcess")
    {
        fileName1 = fileName1 + "/InvisibleProcess/freezer.state";
    }
    else if(group=="CachedProcess")
    {
        fileName1 = fileName1 + "/CachedProcess/freezer.state";
    }
    else
    {
        cout << "组名错误" << endl;
        return 1;
    }

    QFile file1(fileName1);
    if (! file1.exists())
    {
        cout << "文件不存在，请创建分组" << endl;
        return 1;
    }
    else{
        if(!file1.open(QIODevice::WriteOnly|QFile::Truncate))//以写的方式打开文件，如果文件不存在则创建，
        {
            qDebug()<<file1.errorString();
            return 1;
        }
        if(state=="FROZEN"){
            str = "FROZEN\n";
        }
        else if (state=="THAWED"){
            str = "THAWED\n";
        }
        else{
            cout << "freezer状态错误" << endl;
            return 1;
        }
        buf = str.toUtf8();
        file1.write(buf);//写入文件，支持QByteArray和 char * 类型数据写入
        cout << "freezer状态写入分组" << endl;
        file1.close();//关闭文件
    }

    return 0;
}

